/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: _doprnt.c,v 1.6 1994/11/27 13:04:32 mura Exp $
 */

/* System headers */
#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <stdarg.h>
#include <ctype.h>
#include <sys/xstdio.h>

/*
** {֐͑S C locale OƂăvO~OĂB
** ̎dlł͂ȊÕP[ɑΉ鎖͂Ȃ̂ɂ
** ƎvB
*/

/*
** dl --- ݂̂ƂAgcc  long double T|[gĂȂ̂
**	    libc ̓ł؂ɂĂ͍lĂȂB
*/

/* Macros */
#define DEFAULT_PRECISION 6	/* ftHg̕\x */
#define TMPBUFSIZ 512		/* ftHg̕ϊobt@̃TCY */

/* Macros */
#define UPPER_CHARSET "0123456789ABCDEF" /* 啶 */
#define LOWER_CHARSET "0123456789abcdef" /*  */

/* Macros */
#define _P_SHRTINT  0x001	/* short integer [h */
#define _P_LONGINT  0x002	/* long integer [h */
#define _P_LLNGINT  0x004	/* long long integer [h */
#define _P_LONGDBL  0x008	/* long double [h */
#define _P_SHARPEXT 0x010	/* # gtH[}bg̃[h */
#define _P_RUGLEFT  0x020	/* l߃[h */
#define _P_ZEROPAD  0x040	/* [l߃[h */
#define _P_LHEXPFIX 0x080	/* 16ivtBNX */
#define _P_UHEXPFIX 0x100	/* 啶16ivtBNX */
#define _P_OCTAPFIX 0x200	/* 8ivtBNX */
#define _P_BINAPFIX 0x400	/* 2ivtBNX */

/* Macros */
#define DEDIGIT(x) ((x) - '0')
#define ENDIGIT(x) ((x) + '0')

/* File scope functions */
static char *format_L (unsigned long long uval, int flag,
		       int precision, int *size)
{
    char *ptr;
    unsigned int shift, mask;
    static char buffer[64];

    /* ϊpobt@̍ŌɃ|C^ړ */
    ptr = buffer + sizeof buffer;

    /* `FbN */
	shift = 0;
	mask = 0;

    /* 𕶎ɕϊ */
    if (precision != 0) {

	/* Px */
	{

	    unsigned long udivs;
	    unsigned long uvals;

	    /* Pxɕϊ */
	    uvals = (unsigned long) uval;

	    /* VtgŌvZ\ */
	    if (shift > 0) {
		do {
		    *--ptr = ENDIGIT(uvals & mask);
		    uvals = uvals >> shift;
		} while (uvals > 0UL);
	    }

	    /* Vtgł͌vZłȂ */
	    else {
		do {
		    udivs = uvals / 10;
		    *--ptr = ENDIGIT(uvals - udivs * 10);
		    uvals = udivs;
		} while (uvals > 0UL);
	    }

	}

    }

    /* ϊ̃TCYݒ */
    *size = buffer + sizeof buffer - ptr;

    /* ̐擪AhXԂ */
    return ptr;
}

/* File scope functions */
static int format_last (FILE *fp, char *ptr, int flag,
			int sign, int width, int precision, int bodysize)
{
    int n, real_size;
    int string_size;
    unsigned char *p = ptr;

    /* ̒𒲐 */
    string_size = (bodysize
		   + ((sign) ? 1 : 0));

    /* xĒ𒲐 */
    real_size = (precision > string_size) ? precision : string_size;

    /* 1. El߂̂߂̋󔒂o͂ */
    if ((flag & (_P_RUGLEFT | _P_ZEROPAD)) == 0)
	for (n = real_size; n < width; n++)
	    fputc (' ', fp);

    /* 2. o */
    if (sign)
	fputc (sign, fp);

    /* 3. El߂̂߂Ƀ[l߂sȂ */
    if ((flag & (_P_RUGLEFT | _P_ZEROPAD)) == _P_ZEROPAD)
	for (n = real_size; n < width; n++)
	    fputc ('0', fp);

    /* 4. xp̃[l߂sȂ */
    for (n = string_size; n < precision; n++)
	fputc ('0', fp);

    /* 5. lA邢͕{̂o͂ */
    for (n = bodysize; --n >= 0; )
	fputc (*p++, fp);

    /* 6. lߗp̋󔒒sȂ */
    if (flag & _P_RUGLEFT)
	for (n = real_size; n < width; n++)
	    fputc (' ', fp);

    /* o͕Ԃ */
    return (width > real_size) ? width : real_size;
}

/* Functions */
int _doprnt (const char *format, va_list ap, FILE *fp)
{
    char buf;					/* %c pobt@ */
    char *ptr, *tmp;				/* e|̃|C^ */
    int ch;					/* e|̕ */
    int count;					/* o͕ */
    int flag;					/* \[htO */
    int n;					/* e|̐l */
    int precision;				/* \x */
    int sign;					/*  */
    int size;					/* ̒ */
    int width;					/* tB[h */
    long long lval;				/* ̒l */
    const unsigned char *fmt;			/* tH[}bg͗p */

#define GETARG() \
    va_arg (ap, int)

#define UGETARG() \
    va_arg (ap, unsigned int)

    /* tH[}bg͂ */
    for (fmt = format, count = 0;; fmt++) {

	/* ʂ̓̕oCpX */
	while ((ch = *fmt++) && (ch != '%')) {
	    fputc (ch, fp);
	    count++;
	}

	/*  */
	fmt--;

	/* null ɓBȂAI */
	if (ch == '\0')
	    return feof (fp) ? EOF : count;

	/* parser p̃tO */
	flag = 0;
	width = 0;
	precision = -1;
	sign = '\0';

    loop:

	/* ̕o */
	switch (*++fmt) {

	case '\0':
	    return feof (fp) ? EOF : count;

	/*
	 * ̃tH[}bǵA\[hw肷....
	 */

	case ' ':
	    /* space [h + [h override łȂ */
	    if (sign == '\0')
		sign = ' ';
	    goto loop;
	case '-':
	    /* l߃[h */
	    flag |= _P_RUGLEFT;
	    goto loop;
	case '+':
	    /* + [h space [h override ł */
	    sign = '+';
	    goto loop;
	case '0':
	    /* [l߃[h */
	    if (sign != '-' && precision <= 0)
		flag |= _P_ZEROPAD;
	    goto loop;

	/*
	 * ̃tH[}bg͐xwł....
	 */

	case '.':
	    if (*++fmt == '*')
		n = va_arg (ap, int);
	    else {
		n = 0;
		while (isdigit (*fmt))
		    n = 10 * n + DEDIGIT (*fmt++);
		fmt--;
	    }
	    precision = n;
	    goto loop;

	/*
	 * ̃tH[}bg̓tB[h̎wł....
	 */

	case '*':
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':
	    if (*fmt == '*') {
		if ((width = va_arg (ap, int)) < 0) {
		    width = -width;
		    flag |= _P_RUGLEFT;
		}
	    }
	    else {
		n = 0;
		do
		    n = 10 * n + DEDIGIT (*fmt);
		while (isdigit (*++fmt));
		width = n;
		fmt--;
	    }
	    goto loop;

	/*
	 * \....
	 */

	case 'c':
	    buf = (char) va_arg (ap, int);
	    count += format_last (fp, &buf, flag, '\0', width, precision, 1);
	    break;

	/*
	 * \....
	 */

	case 'd':
	    if ((lval = GETARG ()) < 0) {
		lval = -lval;
		sign = '-';
	    }
	    ptr = format_L (lval, flag, precision, &size);
	    count += format_last (fp, ptr, flag, sign, width, precision, size);
	    break;

	/*
	 * \....
	 */

	case 's':
	    /* k|C^`FbN */
	    if ((ptr = va_arg (ap, char *)) == 0)
		ptr = "(null)";

	    /* \xATCY */
	    size = (precision < 0) ? strlen (ptr) :
		(tmp = memchr (ptr, '\0', precision)) ? tmp - ptr : precision;

	    /* o */
	    count += format_last (fp, ptr, flag, '\0', width, size, size);
	    break;

	/*
	 * ȊO....
	 */

	default:
	    fputc (*fmt, fp);
	    count++;
	    break;
	}
    }
}
