* mview.x
* assembler sub routine

	.include iocscall.mac

	.xdef	_tscroll
	.xdef	_clrtext
	.xdef	_allput
	.xdef	_putul

R21	equ	$e8002a
TRAM	equ	$e00000
VDISP	equ	$e88001

	.text

_tscroll:
	move.l	d3,-(sp)
				*upside
	tst.l	4+4(sp)
	bne	scrolldown
*scrollup
	move.w	#$0804,d1
	move.w	#%0000_0000_0000_1111,d3
	bra	@f
scrolldown:
	move.w	#$6f73,d1
	move.w	#%1111_1111_0000_1111,d3
@@
				*d1.high byte: source raster
				*   low  byte: destination raster
	move.w	#16*27/4,d2	*d2          :number of raster to copy
				*d3.high byte: move to (0 : down, -1 : up)
				*d3.low  byte: destination plane(bit 0-3 = plane 0-3)
	suba.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,a1		*ssp
	bsr	_waitvdisp
	IOCS	__B_SUPER

	bra	dorascp

	.even
_clrtext:
	move.l	d3,-(sp)
	lea.l	TRAM,a0		*text vram top
	move.l	4+4(sp),d3	*start y pos
	bpl	@f
	suba.l	a1,a1
	IOCS	__B_SUPER
	movea.l	d0,a1		*ssp
	bra	start
@@
	cmpi.w	#28,d3
	bge	end_rascp
	addq.w	#1,d3
	move.l	d3,d0
	swap.w	d0
	lsr.l	#5,d0
	adda.l	d0,a0
start:
	lea.l	R21,a2
	move.w	(a2),d2		*R21 : text access/graphic clr
	move.w	#%0001_0011_0000,(a2)
		*   text mask on/off
		*    text parallel access on/off
		*      text access plane(3210)
		*           text raster copy/graphic clear page(3210)
	move.w	#1024-1,d1
	moveq.l	#0,d0
clrlp:
	move.l	d0,(a0)+
	dbra	d1,clrlp

	move.w	d2,(a2)
	tst.w	d3
	bpl	@f
	moveq.l	#1,d3
	IOCS	__B_SUPER
@@
	add.w	d3,d3
	add.w	d3,d3
	moveq.l	#29*4-1,d2
	sub.b	d3,d2
*	moveq.l	#16*28/4-1,d2	*number of raster to copy
	move.b	d3,-(sp)
	addq.b	#1,d3
	move.w	(sp)+,d1
	move.b	d3,d1
*	moveq.l	#$0001,d1
	moveq.l	#%0000_1111,d3
dorascp:
	IOCS	__TXRASCPY
end_rascp:
	move.l	(sp)+,d3
	rts

	.even
_waitvdisp:
				*you should call in SUPERVISOR mode
				*destroy :d0,d1,a1
	lea.l	VDISP,a0	*global I/O register(bit 4 = VDISP)
	moveq.l	#4,d0
until_end:
	btst.b	d0,(a0)		*not display ?
	beq	until_end
until_start:
	btst.b	d0,(a0)		*display ?
	bne	until_start

	rts

_allput:
	movem.l	d3-d7/a3-a6,-(sp)
	movem.l	4+9*4(sp),d3/d7/a3	*xpos, num of line, src
	subq.w	#1,d7
	bmi	noput
	suba.l	a1,a1
	IOCS	__B_SUPER
	move.l	d0,-(sp)	*ssp
	bsr	_waitvdisp

	lea.l	R21,a6		*R21 : text access/graphic clr
	move.w	(a6),d6		*original value
	swap.w	d6
	lea.l	TRAM+128*16,a5	*text vram
	moveq.l	#-1,d5		*previous character
	move.w	d5,d6		*previous color
yloop:
	swap.w	d7
	btst	#0,d3
	sne	d7		*init odd flag
	movea.l	a5,a1		*line top
	move.w	d3,d0
	beq	@f
	move.w	#%0001_0011_0000,(a6)
	bsr	nclr		*skip to xpos
@@
	move.b	(a3)+,d6	*color
	moveq.l	#3,d4
	and.b	d6,d4
	moveq.l	#$10,d2
	or.b	d4,d2
	lsl.w	#4,d2
	move.w	d2,(a6)
xloop:
	moveq.l	#8,d2		*font size 8/16 dot
	clr.w	d1		*clear word
	move.b	(a3)+,d1	*read 1 byte
	beq	yloop_ent	*null ?
	bpl	han		*[$00-$7f] ascii
	cmpi.b	#$80,d1		*[$80]     2byte kana
	beq	han2
	cmpi.b	#$9f,d1		*[$81-$9f] sjis kanji
	bls	zen
	cmpi.b	#$df,d1		*[$a0-$df] 1byte kana
	bls	han
	cmpi.b	#$ef,d1		*[$e0-$ef] sjis kanji
	bls	zen
	cmpi.b	#$f4,d1		*[$f0-$f4] 2byte kana
	bhi	han		*[$f5-$ff] control code
han2:
	move.b	d1,-(sp)
	move.w	(sp)+,d1
	move.b	(a3)+,d1
	beq	yloop_ent
han:
	cmp.w	d1,d5		*same to previous ?
	beq	hanput

	move.w	d1,d5
	IOCS	__FNTADR
	movea.l	d0,a2
hanput:
	movea.l	a2,a0
	btst	#3,d6
	bne	rhanput

	move.b	(a0)+,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.b	(a0)+,128*%L-1(a1)
	.endm
	not.b	d7		*odd flag
	bra	xloop
zen:
	move.b	d1,-(sp)
	move.w	(sp)+,d1
	move.b	(a3)+,d1
	beq	yloop_ent
	cmp.w	d1,d5
	beq	zenput

	move.w	d1,d5		*same to previous ?
	IOCS	__FNTADR
	movea.l	d0,a2
zenput:
	movea.l	a2,a0
	btst	#3,d6
	bne	rzenput

	tst.b	d7		*even ?
	beq	wzen

	move.b	(a0)+,(a1)+
	move.b	(a0)+,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.b	(a0)+,128*%L-2(a1)
	move.b	(a0)+,128*%L-1(a1)
	.endm
	bra	xloop
wzen:
	move.w	(a0)+,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.w	(a0)+,128*%L-2(a1)
	.endm
	bra	xloop
yloop_ent:
	move.l	a1,d1
	sub.l	a5,d1
	moveq.l	#96,d0
	sub.w	d1,d0
	ble	@f
	bsr	nclr
@@
	cmpi.b	#3,d4
	beq	nextline
*lineclr
		*argument	a5: address
		*destroy	d0,d1,a0
	moveq.l	#%0001_0011,d0
	eor.b	d4,d0
	lsl.w	#4,d0
	move.w	d0,(a6)

	moveq.l	#0,d0
	moveq.l	#16-1,d1
	movea.l	a5,a0
@@
	.rept 24
	move.l	d0,(a0)+
	.endm
	lea.l	128-96(a0),a0
	dbra	d1,@b
nextline:
	lea.l	128*16(a5),a5	*next vline
	swap.w	d7
	dbra	d7,yloop
end_allput:
	move.l	4+8+9*4(sp),-(sp)
	bsr	_clrtext
	addq.w	#4,sp
	swap.w	d6
	move.w	d6,(a6)		*original value
	movea.l	(sp)+,a1	*ssp
	IOCS	__B_SUPER
noput:
	movem.l	(sp)+,d3-d7/a3-a6
	rts

rhanput:
	move.b	(a0)+,d0
	not.b	d0
	move.b	d0,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.b	(a0)+,d0
	not.b	d0
	move.b	d0,128*%L-1(a1)
	.endm
	not.b	d7		*odd flag
	bra	xloop
rzenput:
	tst.b	d7		*even ?
	beq	rwzen

	move.b	(a0)+,d0
	not.b	d0
	move.b	d0,(a1)+
	move.b	(a0)+,d0
	not.b	d0
	move.b	d0,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.b	(a0)+,d0
	not.b	d0
	move.b	d0,128*%L-2(a1)
	move.b	(a0)+,d0
	not.b	d0
	move.b	d0,128*%L-1(a1)
	.endm
	bra	xloop
rwzen:
	move.w	(a0)+,d0
	not.w	d0
	move.w	d0,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.w	(a0)+,d0
	not.w	d0
	move.w	d0,128*%L-2(a1)
	.endm
	bra	xloop

	.even
nclr:
		*argument	d0: size
		*		a1: address
		*destroy	d1,d2
	moveq.l	#0,d2
	move.l	a1,d1
	andi.w	#1,d1
	beq	@f
	bsr	bclr_ent
	subq.w	#1,d0
	beq	end_nclr
@@
	moveq.l	#3,d1
	and.b	d0,d1		*size % 4

	lsr.w	#2,d0		*size / 4
	bra	lclr_ent
@@
	move.l	d2,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.l	d2,128*%L-4(a1)
	.endm
lclr_ent:
	dbra	d0,@b

	bra	bclr_ent
@@
	move.b	d2,(a1)+
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	move.b	d2,128*%L-1(a1)
	.endm
bclr_ent:
	dbra	d1,@b
end_nclr:
	rts

_putul:
	movem.l	d3/d4/a3,-(sp)
	suba.l	a1,a1
	IOCS	__B_SUPER
	movea.l	d0,a1		*ssp

	movem.l	4+12(sp),d0/d1/d2
				*xpos, ypos, len
	addq.w	#2,d1		*y++
	swap.w	d1
	lsr.l	#5,d1
	add.w	d0,d1		*skip x
	lea.l	TRAM,a0		*text vram top
	lea.l	-128(a0,d1.l),a0
	lea.l	$20000,a2
	adda.l	a0,a2

	lea.l	R21,a3
	move.w	(a3),d4		*R21 : text access/graphic clr
	moveq.l	#-1,d3
	moveq.l	#0,d0
	move.w	d0,(a3)

	andi.w	#1,d1
	beq	@f
	move.b	d0,(a0)+
	move.b	d3,(a2)+
	subq.w	#1,d2
	beq	end_ul
@@
	moveq.l	#3,d1
	and.b	d2,d1		*size % 4

	lsr.w	#2,d2		*size / 4
	bra	lul_ent
@@
	move.l	d0,(a0)+
	move.l	d3,(a2)+
lul_ent:
	dbra	d2,@b

	bra	bul_ent
@@
	move.b	d0,(a0)+
	move.b	d3,(a2)+
bul_ent:
	dbra	d1,@b
end_ul:
	move.w	d4,(a3)
	IOCS	__B_SUPER
	movem.l	(sp)+,d3/d4/a3
	rts

	.even
	.end
