*convert JIS -> SHIFT JIS
*
* unsigned char *jis2sjis(char *destination, char *src)
*
* original jis2sjis.c (libisa) Tetsuya Isaki
*       X68k assembler version Rick

	.cpu 68000

ESC	equ	$1b
SO	equ	$0e
SI	equ	$0f

KANJI	equ	1
ASCII	equ	0
BKANA	equ	$80

	.text
	.even

	.globl _jis2sjis
_jis2sjis:
	movem.l	d3/d4,-(sp)
	movem.l	8+4(sp),a0/a1	*dest, src
	movea.l	a0,a2		*dest
	moveq.l	#0,d0
	moveq.l	#ASCII,d3	*code
	move.l	d3,d4		*old
	bra	loop_ent
loop:
	cmpi.b	#ESC,d0		*change code ?
	bne	so_chk
*escape
	move.b	(a1)+,d1
	move.b	(a1)+,d2
	cmpi.b	#'$',d1
	bne	@f
	cmpi.b	#'B',d2
	beq	chg_kanji

	cmpi.b	#'@',d2
	bne	@f
chg_kanji:			*JIS X 0208-1983 / JIS X 0208-1978
				*(unsupport JIS X 0212-1990)
	moveq.l	#KANJI,d3
	bra	loop_ent
@@
	cmpi.b	#'(',d1
	bne	misc

	cmpi.b	#'B',d2
	beq	chg_ascii

	cmpi.b	#'J',d2
	bne	kana_chk
chg_ascii:			*US-ASCII / JIS X 0201 roma
	moveq.l	#ASCII,d3
	bra	loop_ent
kana_chk:
	cmp.b	#'I',d2		*JIS X 0201(?)
	bne	misc

	moveq.l	#BKANA,d3
	bra	loop_ent
misc:				*suppose unknown codes are ASCII
	move.b	d0,(a0)+
	subq.w	#2,a1
	moveq.l	#ASCII,d3
	bra	loop_ent
so_chk:				*Shift-IN
	cmpi.b	#SO,d0
	bne	si_chk

	move.l	d3,d4
	moveq.l	#BKANA,d3
	bra	loop_ent
si_chk:				*Shift-OUT
	cmpi.b	#SI,d0
	bne	conv

	move.l	d4,d3
	bra	loop_ent
conv:
	tst.b	d3
	bgt	kanji

	or.b	d3,d0
	bra	asc
kanji:
	tst.b	d0
	bmi	asc
				*JIS -> SJIS
	moveq.l	#$80-$5f,d1
	add.w	d0,d1
	andi.w	#$80,d1
	add.w	d0,d1
	moveq.l	#$7e,d0
	add.b	(a1)+,d0	*jis low byte
	addi.w	#$71*2-$1,d1
	lsr.w	#1,d1
	bcs	@f

	cmpi.b	#$7e*2-$1f,d0
	sls	d2
	add.b	#-$7e+$1f+$1,d2
	add.b	d2,d0
@@
	move.b	d1,(a0)+
asc:				*ASCII / 1byte KANA
	move.b	d0,(a0)+
loop_ent:
	move.b	(a1)+,d0
	bne	loop

	move.b	d0,(a0)		*NULL
	move.l	a2,d0		*dest

	movem.l	(sp)+,d3/d4
	rts

	.even
	.end
